% a pack oriented version of requires/1.
% allows us to do without dependency to lib(requires)

requires( Pid ) :-
	ground( Pid ),
	( Pid = _Mod:Name/Arity -> true; Pid = Name/Arity ),
     % This seems awkaward, but Yap doesnt show
     % built-ins in current_predicate/2.
	functor( Head, Name, Arity ),
	( predicate_property(Head,_) ->
		true
		;
		prolog_load_context( directory, Here ),
		( requires_el(Here,Name) ->
			true
			;
			throw(cannot_locate_source_for_required(Name/Arity))
		)
	).

requires_el( Here, Base ) :-
	directory_file_path( Here, Base, Local ),
	requires_el_ne( Local ).
requires_el( Here, Base ) :-
	directory_file_path( Here, lib, Lib ),
	directory_file_path( Lib, Base, Libed ),
	requires_el_ne( Libed ).
requires_el( Here, Base ) :-
	directory_file_path( Stem, prolog, Here ),
	directory_file_path( Stem, src, Src ),
	directory_file_path( Src, Base, Srced ),
	requires_el_ne( Srced ).
requires_el( Here, Base ) :-
	directory_file_path( Stem, prolog, Here ),
	directory_file_path( Stem, 'src/lib', SrcLib ),
	directory_file_path( SrcLib, Base, SrcLibed ),
	requires_el_ne( SrcLibed ).
% auxils ?

requires_el( Dir, Base ) :-
	exists_directory( Dir ),
	directory_file_path( Dir, Base, Libed ),
	requires_el_ne( Libed ).

requires_el_ne( FileNoPl ) :-
	catch( ensure_loaded(FileNoPl), _, fail ).

lib( LibIn ) :-
	( LibIn == os -> Lib = os_lib; Lib = LibIn ),
	( catch(use_module(library(Lib)),_,fail)  ->
		true
		;
		write( 'Library ' ), write( pack(Lib) ), write( ' is not installed in your system'), nl,
		write( 'Install with ' ), write( pack_install(Lib) ), nl
	).
